/**
*   Ray Tracer By Mouse Across 1.0   2008.11
* 	by Foxlively
*/
package
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	[SWF(frameRate='30',backgroundColor="0x111111",width="800",height="600")]
	public class MouseRayTracer extends RayTracer
	{
		/**
		 *是否在鼠标滑过时绘制轨迹 
		 */		
		public var useMouseTrack:Boolean = false;
		/**
		 *鼠标轨迹的颜色 
		 */		
		public var mouseColor:uint = 0xFFFFFF;
		/**
		 *鼠标轨迹的透明度 
		 */		
		public var mouseAlpha:Number = 0.6;
		private var isMouseDown:Boolean = false;
		private var mouseArray:Array = new Array();
		public function MouseRayTracer(){
			super();
			DrawBg(this,800,600);//绘制一个背景（用于相应鼠标事件） 
			this.addEventListener(MouseEvent.MOUSE_DOWN,onDown);
			this.addEventListener(MouseEvent.MOUSE_MOVE,onMove);
			this.addEventListener(MouseEvent.MOUSE_UP,onUp);
			this.addEventListener(MouseEvent.ROLL_OUT,onUp);
			//this.install(this.getChildByName("pp") as Sprite,16,fa);
			//this.addEventListener(Event.ENTER_FRAME,onF);
		}
		override public function clear():void{
			this.mouseArray = [];
			this.graphics.clear();
			super.clear();
		}
		private function onDown(_e:MouseEvent):void{
			clear();
			isMouseDown = true;
			mouseArray[0] ={x:this.mouseX,y:this.mouseY};
			if(useMouseTrack){
				this.graphics.lineStyle(0,mouseColor,mouseAlpha);
				this.graphics.moveTo(this.mouseX,this.mouseY);
			}
		}
		private function onMove(_e:MouseEvent):void{
			if(isMouseDown){
					mouseArray.push({x:this.mouseX,y:this.mouseY});
					if(useMouseTrack){
						this.graphics.lineTo(this.mouseX,this.mouseY);
					}
//				}
			}
		}
		private function onUp(_e:MouseEvent):void{
			if(!this.isMouseDown){
				return;
			}
			if(mouseArray.length<1){
				trace("ALARM:onUp");
			}
			isMouseDown = false;
			this.buildByNoRoArray(this.mouseArray);
		}
		/**
		 *绘制一个背景（用于相应鼠标事件） 
		 * @param _ob
		 * @param _w
		 * @param _h
		 * @param _color
		 * @param _alpha
		 * 
		 */		
		public static function DrawBg(_ob:Sprite,_w:Number=400,_h:Number=400,_color:Number=0xFFFFFF,_alpha:Number=0):void{
			var _bg:Sprite = new Sprite();
			_bg.graphics.beginFill(_color,_alpha);
			_bg.graphics.drawRect(0,0,_w,_h);
			_bg.graphics.endFill();
			_ob.addChildAt(_bg,0);
		}
	}
}